import { ThreeObject3d } from '@angular-three/core';
import { ContentChildren, Directive } from '@angular/core';
import { LOD } from 'three';
export class LodDirective extends ThreeObject3d {
    ngOnInit() {
        this.init();
    }
    ngAfterContentInit() {
        this.ngZone.runOutsideAngular(() => {
            if (this.objectLevels) {
                this.objectLevels.forEach((objectLevel) => {
                    if (objectLevel.object3d) {
                        this._lod.addLevel(objectLevel.object3d, objectLevel.lodDistance);
                    }
                });
            }
        });
    }
    initObject() {
        this._lod = new LOD();
    }
    get object3d() {
        return this._lod;
    }
}
LodDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-lod',
                exportAs: 'ngtLod',
                providers: [{ provide: ThreeObject3d, useExisting: LodDirective }],
            },] }
];
LodDirective.propDecorators = {
    objectLevels: [{ type: ContentChildren, args: [ThreeObject3d,] }]
};
//# sourceMappingURL=lod.directive.js.map