import { ThreeObject3d } from '@angular-three/core';
import { Directive, ContentChildren, NgModule } from '@angular/core';
import { LOD } from 'three';
import { CommonModule } from '@angular/common';

class LodDirective extends ThreeObject3d {
    ngOnInit() {
        this.init();
    }
    ngAfterContentInit() {
        this.ngZone.runOutsideAngular(() => {
            if (this.objectLevels) {
                this.objectLevels.forEach((objectLevel) => {
                    if (objectLevel.object3d) {
                        this._lod.addLevel(objectLevel.object3d, objectLevel.lodDistance);
                    }
                });
            }
        });
    }
    initObject() {
        this._lod = new LOD();
    }
    get object3d() {
        return this._lod;
    }
}
LodDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-lod',
                exportAs: 'ngtLod',
                providers: [{ provide: ThreeObject3d, useExisting: LodDirective }],
            },] }
];
LodDirective.propDecorators = {
    objectLevels: [{ type: ContentChildren, args: [ThreeObject3d,] }]
};

class ThreeLodModule {
}
ThreeLodModule.decorators = [
    { type: NgModule, args: [{
                declarations: [LodDirective],
                imports: [CommonModule],
                exports: [LodDirective],
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { LodDirective, ThreeLodModule };
//# sourceMappingURL=angular-three-core-lod.js.map
